#ifndef _PatchIdealMHDF_F_H_
#define _PatchIdealMHDF_F_H_

#include "FORT_PROTO.H"
#include "REAL.H"

extern "C"
{

// Prototype for Fortran procedure MAXWAVESPEED ...
//
#define FORT_MAXWAVESPEED FORTRAN_NAME( MAXWAVESPEED ,maxwavespeed )
void 
FORT_MAXWAVESPEED(
      CHFp_REAL(cmax)
      ,CHFp_CONST_FRA(cons)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure CONSTOPRIM ...
//
#define FORT_CONSTOPRIM FORTRAN_NAME( CONSTOPRIM ,constoprim )
void 
FORT_CONSTOPRIM(
      CHFp_FRA(W)
      ,CHFp_CONST_FRA(U)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure PRIMTOCONS ...
//
#define FORT_PRIMTOCONS FORTRAN_NAME( PRIMTOCONS ,primtocons )
void 
FORT_PRIMTOCONS(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(W)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure NORMALPRED ...
//
#define FORT_NORMALPRED FORTRAN_NAME( NORMALPRED ,normalpred )
void 
FORT_NORMALPRED(
      CHFp_FRA(WMinus)
      ,CHFp_FRA(WPlus)
      ,CHFp_CONST_FRA(W)
      ,CHFp_CONST_FRA(dW)
      ,CHFp_CONST_REAL(dtbydx)
      ,CHFp_CONST_INT(normdir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure RIEMANN ...
//
#define FORT_RIEMANN FORTRAN_NAME( RIEMANN ,riemann )
void 
FORT_RIEMANN(
      CHFp_FRA(Wgdnv)
      ,CHFp_CONST_FRA(WLeft)
      ,CHFp_CONST_FRA(WRight)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure GETFLUX ...
//
#define FORT_GETFLUX FORTRAN_NAME( GETFLUX ,getflux )
void 
FORT_GETFLUX(
      CHFp_FRA(F)
      ,CHFp_CONST_FRA(Wgdnv)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure UPDATECONS ...
//
#define FORT_UPDATECONS FORTRAN_NAME( UPDATECONS ,updatecons )
void 
FORT_UPDATECONS(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(F)
      ,CHFp_CONST_REAL(dtbydx)
      ,CHFp_CONST_INT(idir)
      ,CHFp_BOX(box) );

// Prototype for Fortran procedure FILTERCONS ...
//
#define FORT_FILTERCONS FORTRAN_NAME( FILTERCONS ,filtercons )
void 
FORT_FILTERCONS(
      CHFp_FRA(U)
      ,CHFp_CONST_FRA(Uold)
      ,CHFp_CONST_REAL(dt)
      ,CHFp_CONST_REAL(dx)
      ,CHFp_BOX(box) );

}
#endif
