
#ifndef WRAPPER
#include "Vector.H"
#include "Box.H"
#include <string>
#include "DisjointBoxLayout.H"
#include "LevelData.H"
#include "FArrayBox.H"
#include "LDF.H"
#include "parstream.H"
using std::string;
#endif

#define VECTOR_MACRO(class) \
class& vget_##class(Vector<class>& vector, int index) { return vector[index];} \
;\
void vset_##class(Vector<class>& vector, int i, class val) { vector[i]=val;} \
;\
class val_##class(const Vector<class>& vector, int index) { return vector[index];} \
;\
int vsize_##class(const Vector<class>& vector) { return vector.size();} \
;\
Vector<class> vcopy_##class(const Vector<class>& vector) {return vector;} \
;\
void vpush_back_##class(Vector<class>& vec, const class& in){vec.push_back(in);}\
;\
void vappend_##class(Vector<class>& mod, const Vector<class>& in){mod.append(in);}\
;\
void vresize_##class(Vector<class>& mod, int s) {mod.resize(s);}\
;\
Vector<class> vnew_##class(int s) {return Vector<class>(s);}\


VECTOR_MACRO(Box);

VECTOR_MACRO(int);

VECTOR_MACRO(string);

VECTOR_MACRO(DisjointBoxLayout);

VECTOR_MACRO(LDF);
